/*
 *
 * CLEX File Manager
 *
 * Copyright (C) 1997-2000 Tempest s.r.o. http://www.tempest.sk
 * Copyright (C) 2001-2002 Vlado Potisk <vlado_potisk@clex.sk>
 *
 * CLEX is free software without warranty of any kind; see the
 * GNU General Public License as set out in the "COPYING" document
 * which accompanies the CLEX File Manager package.
 *
 * CLEX can be downloaded from http://www.clex.sk
 *
 */

#include <autoconf.h>

#include <sys/types.h>
#include <stdio.h>
#ifdef MAJOR_IN_MKDEV
# include <sys/mkdev.h>
#endif
#ifdef MAJOR_IN_SYSMACROS
# include <sys/sysmacros.h>
#endif

/* utility to compute device minor and major number sizes */

int
main(int argc, char *argv[])
{
	unsigned int i, maxn, minorlen, majorlen;
	dev_t all_ones;

	for (i = 0; i < sizeof(all_ones); i++)
		((char *)&all_ones)[i] = (char)0x7F;
		/* was 0xFF, that's why the name 'all_ones' */

	for (majorlen = 0, maxn = major(all_ones); maxn > 0; maxn /= 0x100)
		majorlen++;	/* in bytes */
	majorlen = 1 + (241 * majorlen) / 100;	/* in decimal digits */
	/* log 256 at base 10 is approximately 241/100 */

	for (minorlen = 0, maxn = minor(all_ones); maxn > 0; maxn /= 0x100)
		minorlen += 2;	/* in hex digits */

	printf(
	  "#define DEV_FORMAT\t\"%%%uu:0x%%0%uX\"\n"
	  "#define FE_DEV_STR\t%u\n",
	  majorlen,minorlen,majorlen + minorlen + 4
	);

	return 0;
}
